export declare enum MIOCorePlatformType {
    Unknown = 0,
    Node = 1,
    Safari = 2,
    Chrome = 3
}
export declare function NSClassFromString(className: string): any;
export declare function MIOCoreGetPlatform(): MIOCorePlatformType;
export declare function MIOCoreGetPlatformLocale(): any;
export declare function MIOCoreGetPlatformLanguage(): any;
export declare function MIOCoreIsPhone(): boolean;
export declare function MIOCoreIsPad(): boolean;
export declare function MIOCoreIsMobile(): boolean;
export declare function MIOCoreBundleGetMainURLString(): string;
export declare function MIOCoreBundleGetContentsFromURLString(path: string, target: any, completion: any): void;
export declare function MIOCoreCreateMD5(s: any): string;
export declare function MIOCoreStringHasPreffix(str: any, preffix: any): boolean;
export declare function MIOCoreStringHasSuffix(str: any, suffix: any): boolean;
export declare function MIOCoreStringAppendPathComponent(string: string, path: any): string;
export declare function MIOCoreStringLastPathComponent(string: string): string;
export declare function MIOCoreStringPathExtension(string: string): string;
export declare function MIOCoreStringDeletingLastPathComponent(string: string): string;
export declare function MIOCoreStringStandardizingPath(string: any): string;
export declare function MIOCoreStringSetLocalizedStrings(data: any): void;
export declare function MIOCoreStringGetLocalizedStrings(): any;
export declare function MIOCoreStringLocalizeString(key: string, defaultValue: string): any;
export declare class MIOCoreLexer {
    private input;
    private tokenTypes;
    private tokens;
    private tokenIndex;
    private ignoreTokenTypes;
    constructor(string: string);
    addTokenType(type: any, regex: any): void;
    ignoreTokenType(type: any): void;
    tokenize(): void;
    private _tokenize;
    nextToken(): any;
    prevToken(): any;
}
export declare function MIOCoreAddLanguage(lang: any, url: any): void;
export declare function MIOCoreGetLanguages(): any;
export interface MIOCoreHTMLParserDelegate {
    parserDidStartElement(parser: MIOCoreHTMLParser, element: string, attributes: any): void;
    parserDidEndElement(parser: MIOCoreHTMLParser, element: string): void;
    parserFoundCharacters(parser: MIOCoreHTMLParser, characters: string): void;
    parserFoundComment(parser: MIOCoreHTMLParser, comment: string): void;
    parserDidStartDocument(parser: MIOCoreHTMLParser): void;
    parserDidEndDocument(parser: MIOCoreHTMLParser): void;
}
export declare enum MIOCoreHTMLParserTokenType {
    Identifier = 0,
    OpenTag = 1,
    CloseTag = 2,
    OpenCloseTag = 3,
    InlineCloseTag = 4,
    Question = 5,
    Exclamation = 6,
    Equal = 7,
    Quote = 8,
    Commentary = 9,
    End = 10
}
export declare class MIOCoreHTMLParser {
    private string;
    private stringIndex;
    private delegate;
    private exceptionsTags;
    initWithString(string: string, delegate: MIOCoreHTMLParserDelegate): void;
    private nextChar;
    private prevChar;
    private getChars;
    private readToken;
    private minor;
    private major;
    private exclamation;
    private lastTokenIndex;
    private lastTokenValue;
    private prevToken;
    private nextToken;
    parse(): void;
    private unexpectedToken;
    private openTag;
    private openElement;
    private attributes;
    private closeTag;
    private closeElement;
    private comment;
    private foundChars;
    private readToNextString;
}
export declare class MIOCoreBundle {
}
export declare function MIOCoreBundleSetAppResource(resource: string, type: string, content: string): void;
export declare function MIOCoreBundleGetAppResource(resource: string, type: string): any;
export declare class MIOCoreBundleHTMLParser implements MIOCoreHTMLParserDelegate {
    private text;
    private result;
    private isCapturing;
    private elementCapturingCount;
    constructor(text: any);
    parse(): string;
    parserDidStartElement(parser: MIOCoreHTMLParser, element: string, attributes: any): void;
    private currentString;
    private currentStringLocalizedKey;
    parserFoundCharacters(parser: MIOCoreHTMLParser, characters: string): void;
    parserFoundComment(parser: MIOCoreHTMLParser, comment: string): void;
    parserDidEndElement(parser: MIOCoreHTMLParser, element: string): void;
    parserDidStartDocument(parser: MIOCoreHTMLParser): void;
    parserDidEndDocument(parser: MIOCoreHTMLParser): void;
    private openTag;
    private closeTag;
    private translateCharacters;
}
export declare class MIOCoreBundle_web extends MIOCoreBundle {
    baseURL: string;
    private _layoutWorker;
    private _layoutQueue;
    private _layoutCache;
    private _isDownloadingResource;
    loadHTMLFromPath(path: any, target: any, completion: any): void;
    private checkQueue;
    private layerDidDownload;
    private _checkDownloadCount;
}
export declare class NSPoint {
    x: number;
    y: number;
    static Zero(): NSPoint;
    constructor(x: any, y: any);
}
export declare class NSRange {
    location: number;
    length: number;
    constructor(location: any, length: any);
}
export declare function NSMaxRange(range: NSRange): number;
export declare function NSEqualRanges(range1: NSRange, range2: NSRange): boolean;
export declare function NSLocationInRange(location: number, range: NSRange): boolean;
export declare function NSIntersectionRange(range1: NSRange, range2: NSRange): NSRange;
export declare function NSUnionRange(range1: NSRange, range2: NSRange): NSRange;
export declare class NSRect {
    origin: NSPoint;
    size: NSSize;
    static Zero(): NSRect;
    static rectWithValues(x: any, y: any, w: any, h: any): NSRect;
    constructor(p: any, s: any);
}
export declare class NSSize {
    width: number;
    height: number;
    static Zero(): NSSize;
    constructor(w: any, h: any);
    isEqualTo(size: any): boolean;
}
/**
 * Created by godshadow on 26/3/16.
 */
export declare class NSObject {
    private _className;
    getClassName(): string;
    readonly className: string;
    keyPaths: {};
    init(): void;
    private _notifyValueChange;
    willChangeValueForKey(key: string): void;
    didChangeValueForKey(key: string): void;
    willChangeValue(key: string): void;
    didChangeValue(key: string): void;
    private _addObserver;
    private _keyFromKeypath;
    addObserver(obs: any, keypath: string, context?: any): void;
    removeObserver(obs: any, keypath: string): void;
    setValueForKey(value: any, key: string): void;
    valueForKey(key: string): any;
    valueForKeyPath(keyPath: string): any;
    copy(): any;
    performSelector(selector: string): any;
    performSelectorOnMainThread(selector: string, arg: any, waitUntilDone: boolean): void;
}
export declare class NSNull extends NSObject {
    static nullValue(): NSNull;
}
export declare class NSError extends NSObject {
    errorCode: number;
}
/**
 * Created by godshadow on 9/4/16.
 */
export declare class NSBundle extends NSObject {
    url: NSURL;
    private static _mainBundle;
    static mainBundle(): NSBundle;
    initWithURL(url: NSURL): void;
    loadNibNamed(name: string, owner: any, options: any): void;
    pathForResourceOfType(resource: string, type: string): any;
}
export interface NSCoding {
    initWithCoder?(coder: NSCoder): void;
    encodeWithCoder?(coder: NSCoder): void;
}
export declare class NSCoder extends NSObject {
    decodeIntegerForKey(key: string): any;
    decodeObjectForKey(key: string): any;
}
export declare class NSKeyedUnarchiver extends NSCoder {
    static unarchiveTopLevelObjectWithData(data: string): any;
    private objects;
    _parseData(data: string, error: any): any;
    private classFromInfo;
    private createObjectFromInfo;
    private currentInfo;
    private createObject;
    decodeObjectForKey(key: string): any;
    private createArray;
    private createDictionary;
    private valueFromInfo;
}
export declare class NSNumber extends NSObject {
    static numberWithBool(value: any): NSNumber;
    static numberWithInteger(value: any): NSNumber;
    static numberWithFloat(value: any): NSNumber;
    protected storeValue: any;
    initWithBool(value: any): void;
    initWithInteger(value: any): void;
    initWithFloat(value: any): void;
}
export declare class NSDecimalNumber extends NSNumber {
    static decimalNumberWithString(str: string): NSDecimalNumber;
    static one(): NSDecimalNumber;
    static zero(): NSDecimalNumber;
    static numberWithBool(value: any): NSDecimalNumber;
    static numberWithInteger(value: any): NSDecimalNumber;
    static numberWithFloat(value: any): NSDecimalNumber;
    initWithString(str: string): void;
    initWithDecimal(value: any): void;
    _initWithValue(value: any): void;
    decimalNumberByAdding(value: NSDecimalNumber): NSDecimalNumber;
    decimalNumberBySubtracting(value: NSDecimalNumber): NSDecimalNumber;
    decimalNumberByMultiplyingBy(value: NSDecimalNumber): NSDecimalNumber;
    decimalNumberByDividingBy(value: NSDecimalNumber): NSDecimalNumber;
    readonly decimalValue: any;
    readonly floatValue: any;
}
export declare function NSLocalizeString(key: string, defaultValue: string): any;
/**
 * Created by godshadow on 11/3/16.
 */
export declare enum NSDateFirstWeekDay {
    Sunday = 0,
    Monday = 1
}
export declare function NSDateSetFirstWeekDay(day: NSDateFirstWeekDay): void;
export declare function NSDateGetStringForMonth(month: any): string;
export declare function NSDateGetStringForDay(day: number): string;
export declare function NSDateGetDayFromDate(date: any): any;
export declare function NSDateGetMonthFromDate(date: Date): number;
export declare function NSDateGetYearFromDate(date: Date): number;
export declare function NSDateGetDayStringFromDate(date: any): string;
export declare function NSDateGetString(date: any): string;
export declare function NSDateGetDateString(date: any): string;
export declare function NSDateGetTimeString(date: any): string;
export declare function NSDateGetUTCString(date: any): string;
export declare function NSDateGetUTCDateString(date: any): string;
export declare function NSDateGetUTCTimeString(date: any): string;
export declare function NSDateFromString(string: any): Date;
export declare function NSDateToUTC(date: any): Date;
export declare function NSDateAddDaysToDateString(dateString: any, days: any): string;
export declare function NSDateRemoveDaysToDateString(dateString: any, days: any): string;
export declare function NSDateFromMiliseconds(miliseconds: any): Date;
export declare function isDate(x: any): boolean;
export declare function NSDateToday(): Date;
export declare function NSDateNow(): Date;
export declare function NSDateTodayString(): string;
export declare function NSDateYesterday(): Date;
export declare function NSDateTomorrow(): Date;
export declare function NSDateGetFirstDayOfTheWeek(date: Date): Date;
export declare function NSDateGetLastDayOfTheWeek(date: Date): Date;
export declare function NSDateGetFirstDateOfTheMonth(month: any, year: any): Date;
export declare function NSDateGetFirstDayOfTheMonth(month: any, year: any): number;
export declare function NSDateGetLastDateOfTheMonth(month: any, year: any): Date;
export declare function NSDateGetLastDayOfTheMonth(month: any, year: any): number;
export declare function NSDateCopy(date: Date): Date;
/**
 * Created by godshadow on 15/3/16.
 */
export declare class NSUUID extends NSObject {
    static UUID(): NSUUID;
    private _uuid;
    init(): void;
    readonly UUIDString: string;
}
/**
 * Created by godshadow on 1/5/16.
 */
export declare enum NSPredicateComparatorType {
    Equal = 0,
    Less = 1,
    LessOrEqual = 2,
    Greater = 3,
    GreaterOrEqual = 4,
    Distinct = 5,
    Contains = 6,
    NotContains = 7,
    In = 8,
    NotIn = 9
}
export declare enum NSPredicateRelationshipOperatorType {
    ANY = 0,
    ALL = 1
}
export declare enum NSPredicateOperatorType {
    OR = 0,
    AND = 1
}
export declare enum NSPredicateBitwiseOperatorType {
    OR = 0,
    AND = 1,
    XOR = 2
}
export declare enum NSPredicateType {
    Predicate = 0,
    Item = 1,
    Operation = 2
}
export declare class NSPredicateOperator {
    type: any;
    static andPredicateOperatorType(): NSPredicateOperator;
    static orPredicateOperatorType(): NSPredicateOperator;
    constructor(type: any);
}
export declare enum NSPredicateItemValueType {
    Undefined = 0,
    UUID = 1,
    String = 2,
    Number = 3,
    Boolean = 4,
    Null = 5,
    Property = 6
}
export declare class NSPredicateItem {
    relationshipOperation: NSPredicateRelationshipOperatorType;
    bitwiseOperation: NSPredicateBitwiseOperatorType;
    bitwiseKey: string;
    bitwiseValue: any;
    key: any;
    comparator: any;
    value: any;
    valueType: NSPredicateItemValueType;
    evaluateObject(object: any, key?: any, lvalue?: any): boolean;
    evaluateRelationshipObject(object: any): boolean;
    evaluateBitwaseOperatorObject(object: any): boolean;
}
export declare class NSPredicateGroup {
    predicates: any[];
    evaluateObject(object: any): boolean;
}
export declare enum NSPredicateTokenType {
    Identifier = 0,
    UUIDValue = 1,
    StringValue = 2,
    NumberValue = 3,
    BooleanValue = 4,
    NullValue = 5,
    PropertyValue = 6,
    MinorOrEqualComparator = 7,
    MinorComparator = 8,
    MajorOrEqualComparator = 9,
    MajorComparator = 10,
    EqualComparator = 11,
    DistinctComparator = 12,
    ContainsComparator = 13,
    NotContainsComparator = 14,
    InComparator = 15,
    NotIntComparator = 16,
    BitwiseAND = 17,
    BitwiseOR = 18,
    OpenParenthesisSymbol = 19,
    CloseParenthesisSymbol = 20,
    Whitespace = 21,
    AND = 22,
    OR = 23,
    ANY = 24,
    ALL = 25
}
export declare class NSPredicate extends NSObject {
    predicateGroup: any;
    private lexer;
    static predicateWithFormat(format: any): NSPredicate;
    initWithFormat(format: any): void;
    private _predicateFormat;
    readonly predicateFormat: string;
    evaluateObject(object: NSObject): any;
    private tokenizeWithFormat;
    private parse;
    private parsePredicates;
    private nextPredicateItem;
    private property;
    private comparator;
    private value;
    private booleanFromString;
    private nullFromString;
}
export declare function _NSPredicateFilterObjects(objs: any, predicate: any): any;
export declare class NSSet extends NSObject {
    static set(): NSSet;
    private _objects;
    addObject(object: any): void;
    removeObject(object: any): void;
    removeAllObjects(): void;
    indexOfObject(object: any): number;
    containsObject(object: any): boolean;
    objectAtIndex(index: any): any;
    readonly allObjects: any[];
    readonly count: number;
    readonly length: number;
    copy(): NSSet;
    filterWithPredicate(predicate: NSPredicate): any;
    addObserver(obs: any, keypath: string, context?: any): void;
}
export declare function NSIndexPathEqual(indexPath1: NSIndexPath, indexPath2: NSIndexPath): boolean;
export declare class NSIndexPath extends NSObject {
    static indexForRowInSection(row: number, section: number): NSIndexPath;
    static indexForColumnInRowAndSection(column: number, row: number, section: number): NSIndexPath;
    private indexes;
    add(value: number): void;
    readonly section: any;
    readonly row: any;
    readonly item: any;
    readonly column: any;
    isEqualToIndexPath(indexPath: NSIndexPath): boolean;
}
export declare class NSLocale extends NSObject {
    languageIdentifier: string;
    countryIdentifier: string;
    static currentLocale(): any;
    static _setCurrentLocale(localeIdentifier: string): void;
    initWithLocaleIdentifier(identifer: string): void;
    readonly decimalSeparator: string;
    readonly currencySymbol: string;
    readonly currencyCode: string;
    readonly groupingSeparator: string;
}
export declare class NSFormatter extends NSObject {
    stringForObjectValue(value: any): any;
    getObjectValueForString(str: string): void;
    editingStringForObjectValue(value: any): void;
    isPartialStringValid(str: string): [boolean, string];
}
export declare enum NSDateFormatterStyle {
    NoStyle = 0,
    ShortStyle = 1,
    MediumStyle = 2,
    LongStyle = 3,
    FullStyle = 4
}
export declare class NSDateFormatter extends NSFormatter {
    dateStyle: NSDateFormatterStyle;
    timeStyle: NSDateFormatterStyle;
    private browserDateSeparatorSymbol;
    init(): void;
    dateFromString(str: string): Date;
    stringFromDate(date: Date): string;
    stringForObjectValue(value: any): string;
    isPartialStringValid(str: string): [boolean, string];
    private _parse;
    private _parseDate;
    private _parseDay;
    private _validateDay;
    private _parseMonth;
    private _validateMonth;
    private _parseYear;
    private _validateYear;
    protected iso8601DateStyle(date: Date): string;
    private _shortDateStyle;
    private _fullDateStyle;
    private _parseTime;
    private _parseHour;
    private _parseMinute;
    private _parseSecond;
    protected iso8601TimeStyle(date: Date): string;
    private _shortTimeStyle;
}
export declare class NSISO8601DateFormatter extends NSDateFormatter {
    static iso8601DateFormatter(): NSISO8601DateFormatter;
    timeZone: any;
    dateFromString(str: string): Date;
    stringFromDate(date: Date): string;
}
export declare enum NSNumberFormatterStyle {
    NoStyle = 0,
    DecimalStyle = 1,
    CurrencyStyle = 2,
    CurrencyISOCodeStyle = 3,
    PercentStyle = 4
}
export declare enum _NSNumberFormatterType {
    Int = 0,
    Decimal = 1
}
export declare class NSNumberFormatter extends NSFormatter {
    numberStyle: NSNumberFormatterStyle;
    locale: NSLocale;
    minimumFractionDigits: number;
    maximumFractionDigits: number;
    groupingSeparator: any;
    currencySymbol: any;
    currencyCode: any;
    private currencyHasSpaces;
    private currencyIsRight;
    init(): void;
    numberFromString(str: string): any;
    stringFromNumber(number: number): string;
    stringForObjectValue(value: any): string;
    private round;
    private stringByAppendingCurrencyString;
    isPartialStringValid(str: string): [boolean, string];
    private _parse;
}
/**
 * Created by godshadow on 21/3/16.
 */
export declare class NSTimer extends NSObject {
    private _timerInterval;
    private _repeat;
    private _target;
    private _completion;
    private _coreTimer;
    static scheduledTimerWithTimeInterval(timeInterval: any, repeat: any, target: any, completion: any): NSTimer;
    initWithTimeInterval(timeInterval: any, repeat: any, target: any, completion: any): void;
    fire(): void;
    invalidate(): void;
    private _timerCallback;
}
/**
 * Created by godshadow on 11/3/16.
 */
export declare class NSNotification {
    name: any;
    object: any;
    userInfo: any;
    constructor(name: any, object: any, userInfo: any);
}
export declare class NSNotificationCenter {
    private static _sharedInstance;
    notificationNames: {};
    constructor();
    static defaultCenter(): NSNotificationCenter;
    addObserver(obs: any, name: any, fn: any): void;
    removeObserver(obs: any, name: any): void;
    postNotification(name: any, object: any, userInfo?: any): void;
}
/**
 * Created by godshadow on 29/09/2016.
 */
export declare class NSUserDefaults {
    private static _sharedInstance;
    constructor();
    static standardUserDefaults(): NSUserDefaults;
    setBooleanForKey(key: any, value: boolean): void;
    booleanForKey(key: any): boolean;
    setValueForKey(key: string, value: any): void;
    valueForKey(key: string): any;
    removeValueForKey(key: string): void;
}
export declare enum NSURLTokenType {
    Protocol = 0,
    Host = 1,
    Path = 2,
    Param = 3,
    Value = 4
}
export declare class NSURL extends NSObject {
    baseURL: NSURL;
    absoluteString: string;
    scheme: string;
    user: string;
    password: any;
    host: string;
    port: number;
    hostname: string;
    path: string;
    file: string;
    pathExtension: string;
    params: any[];
    static urlWithString(urlString: string): NSURL;
    initWithScheme(scheme: string, host: string, path: string): void;
    initWithURLString(urlString: string): void;
    private _parseURLString;
    urlByAppendingPathComponent(path: string): NSURL;
    standardizedURL(): NSURL;
}
export declare class NSURLRequest extends NSObject {
    url: NSURL;
    httpMethod: string;
    httpBody: any;
    headers: any[];
    binary: boolean;
    download: boolean;
    static requestWithURL(url: NSURL): NSURLRequest;
    initWithURL(url: NSURL): void;
    setHeaderField(field: any, value: any): void;
}
/**
 * Created by godshadow on 14/3/16.
 */
export declare class NSURLConnection {
    request: NSURLRequest;
    delegate: any;
    blockFN: any;
    blockTarget: any;
    private xmlHttpRequest;
    initWithRequest(request: NSURLRequest, delegate: any): void;
    initWithRequestBlock(request: NSURLRequest, blockTarget: any, blockFN: any): void;
    start(): void;
}
export interface NSXMLParserDelegate {
    parserDidStartDocument?(parser: NSXMLParser): any;
    parserDidEndDocument?(parser: NSXMLParser): any;
    parserDidStartElement?(parser: NSXMLParser, element: string, attributes: any): any;
    parserDidEndElement?(parser: NSXMLParser, element: string): any;
    parserFoundCharacters?(parser: NSXMLParser, characters: string): any;
    parserFoundComment?(parser: NSXMLParser, comment: string): any;
}
export declare enum NSXMLTokenType {
    Identifier = 0,
    QuestionMark = 1,
    ExclamationMark = 2,
    OpenTag = 3,
    CloseTag = 4,
    Slash = 5,
    Quote = 6,
    WhiteSpace = 7,
    End = 8
}
export declare class NSXMLParser extends NSObject {
    private str;
    private delegate;
    private strIndex;
    private elements;
    private attributes;
    private currentElement;
    private currentTokenValue;
    private lastTokenValue;
    private ignoreWhiteSpace;
    initWithString(str: string, delegate: NSXMLParserDelegate): void;
    private nextChar;
    private prevChar;
    private readToken;
    private nextToken;
    private prevToken;
    parse(): void;
    private openTag;
    private questionMark;
    private exclamationMark;
    private xmlOpenTag;
    private xmlCloseTag;
    private beginElement;
    private endElement;
    private attribute;
    private decodeAttribute;
    private slash;
    private closeTag;
    private didStartElement;
    private didEndElement;
    private text;
    private comments;
    private error;
}
export declare class NSOperation extends NSObject {
    name: string;
    target: any;
    completion: any;
    private _dependencies;
    readonly dependencies: any[];
    private _isExecuting;
    readonly isExecuting: boolean;
    private setExecuting;
    private _isFinished;
    readonly isFinished: boolean;
    private setFinished;
    private _ready;
    private setReady;
    readonly ready: boolean;
    addDependency(operation: NSOperation): void;
    main(): void;
    start(): void;
    executing(): boolean;
    finished(): boolean;
    observeValueForKeyPath(keyPath: string, type: string, object: any, ctx: any): void;
    private checkDependecies;
}
export declare class NSOperationQueue extends NSObject {
    private _operations;
    addOperation(operation: NSOperation): void;
    removeOperation(operation: NSOperation): void;
    readonly operations: any[];
    readonly operationCount: () => number;
    private _suspended;
    suspended: any;
    private setSupended;
    observeValueForKeyPath(keyPath: string, type: string, object: any, ctx: any): void;
}
export declare function NSLog(format: any): void;
/**
 * Created by godshadow on 28/09/2016.
 */
export declare class NSSortDescriptor extends NSObject {
    key: any;
    ascending: boolean;
    static sortDescriptorWithKey(key: any, ascending: any): NSSortDescriptor;
    initWithKey(key: any, ascending: any): void;
}
export declare function _NSSortDescriptorSortObjects(objs: any, sortDescriptors: any): any;
export declare enum NSPropertyListReadOptions {
    None = 0
}
export declare enum NSPropertyListFormatformat {
    None = 0
}
export declare class NSPropertyListSerialization extends NSObject {
    static propertyListWithData(data: string, options: NSPropertyListReadOptions, format: NSPropertyListFormatformat, error: NSError): any;
    private data;
    initWithData(data: string, options: NSPropertyListReadOptions, format: NSPropertyListFormatformat): void;
    private rootItem;
    private _parse;
    private currentElement;
    private currentElementType;
    private currentValue;
    private currentKey;
    private currentString;
    private itemStack;
    parserDidStartElement(parser: NSXMLParser, element: string, attributes: any): void;
    parserFoundCharacters(parser: NSXMLParser, characters: string): void;
    parserDidEndElement(parser: NSXMLParser, element: string): void;
    parserDidEndDocument(parser: NSXMLParser): void;
}
